# Kompira リリースノート

---
## Ver.1.6.7 (2022/11/21)
### 動作環境
- Amazon Linux 2 に対応しました。
    - 以下の AMI で動作確認を行なっています。
        - ami-01154243795368525: Amazon Linux 2 AMI 2.0.20220912.1 x86_64 HVM gp2
        - ami-078296f82eb463377: Amazon Linux 2 Kernel 5.10 AMI 2.0.20220912.1 x86_64 HVM gp2
- Azure および AWS で KE インストール済みVMイメージの提供を開始しました。
    - 詳しくは「[Kompira Enterprise クラウドイメージ](https://docbase.io/posts/2673377/sharing/e987093b-5e01-4bd2-8e61-cc5ca73d45bd)」を参照してください。

### 新機能
- チャネル型に新しいメソッド pop_message, peek_message, delete_message, clear_messages が追加されました。
    - `Channel.pop_message(index=0)`: チャネルのメッセージキューから指定したインデックス（省略時は先頭）のメッセージを取得します。取得したメッセージはメッセージキューから削除されます。
    - `Channel.peek_message(index=0)`: チャネルのメッセージキューから指定したインデックス（省略時は先頭）のメッセージを参照します。参照したメッセージはメッセージキューから削除されずに残ります。
    - `Channel.delete_message(*msgid)`: チャネルのメッセージキューから指定したメッセージ ID に対応するメッセージを削除します。
    - `Channel.clear_messages()`: チャネルのメッセージキューを空にします。
    - 詳しくはマニュアル「5.3.6.2. メソッド」を参照してください。
- イベントジョブに受信したメッセージを削除せずに参照するための新しいキーワード引数  peek_mode が追加されました。
    - チャネルオブジェクトに対するイベントジョブで peek_mode=true を指定すると、メッセージ受信時に対象チャネルのメッセージキューの先頭メッセージを（削除せずに）参照します。peek_mode=true を指定すると結果の構造も変わり、対象チャネルオブジェクト内で当該メッセージを識別するID値とメッセージ本体を含むリスト [msgid, message] を $RESULT に返します。

        ```
        [chan = ./ChannelObject] ->
        <chan: peek_mode=true> ->
        [msgid = $RESULT[0], message = $RESULT[1]] ->
            ...
        [chan.delete_message: msgid]
        ```
    - peek_mode=true を指定したときはチャネルから当該メッセージは削除されていないので、再度イベントジョブを実行すると同じメッセージを得ることになります。メッセージの処理を終えるなど、チャネルから当該メッセージを再取得する必要がなくなった場合は、メッセージIDを指定して `Channel.delete_message()` を呼び出すことで、当該メッセージを削除することができます。
    - 従来の（peek_mode を指定しない）イベントジョブではチャネルからメッセージを受信すると、その時点でデータベースからメッセージデータは削除されます。そのため受信したメッセージに応じた後処理が完了していない期間にシステムがダウンすると、メッセージとそれに応じた処理は失われて再実行もできないことになります。そうしたことが許容できないような場面で、peek_mode を利用することでメッセージの再処理が出来るようになります。
    - 詳しくはマニュアル「4.6.5. イベントジョブ」を参照してください。
- ZIP形式のインポート・エクスポートに対応しました。
    - manage.py export_data に --zip-mode オプションを付けると、ZIP ファイル形式でエクスポートできるようになりました。
    - manage.py import_data は ZIP 形式でエクスポートされたファイルをインポートできるようになりました。
- インポート時に設定オブジェクトのデータを上書きするオプションを追加しました。
    - これまでインポート時に Config 型オブジェクトの設定データは上書きされませんでしたが、manage.py import_data または manage.py import_dir に --update-config-mode オプションを指定すると上書き出来るようになりました。なお --overwrite-mode オプションも同時に指定する必要がありますのでご注意ください。
- ディレクトリ形式エクスポートで添付ファイルを YAML に含めるためのオプションを追加しました。
    - manage.py export_dir に --inline-attachments オプションを付けると、（従来通り）添付ファイルデータを実ファイルではなく YAMLファイルに含めて出力します。
- エクスポート時に添付ファイルを出力しないことを指定できるようになりました。
    - manage.py export_dir または manage.py export_data に--without-attachments オプションを付けると、添付ファイルデータを出力しなくなります。
- 管理コマンド manage.py pop_channel および manage.py peek_channel で処理するメッセージの位置と個数を指定できるようになりました。
    - --index オプションで取得または参照するメッセージの位置を指定することができるようになりました。
    - --count オプションで取得または参照するメッセージの個数を指定することができるようなりました。
- 添付ファイル移行ツール (tools/convert_files.py) を追加しました。
    - Ver.1.5系、および、Ver.1.6.3 以前の Kompira Enterprise 上で作成された添付ファイルデータを、Ver.1.6.4以降の Kompira に移行するためのツールです。
    - 使い方は「[convert_files.py を用いた添付ファイルデータの移行手順](https://docbase.io/posts/2678161/sharing/40645b3c-aac6-4ae4-a65c-4840f1d44d52)」を参照してください。
- インストーラ(install.sh)にインストールのみ実施するオプションを追加しました。
    - install.sh に --install-only オプションを付けると、インストールのみ実施して kompira の各サービスの起動は行ないません。
- REST-API でのオブジェクト一覧取得時の order_by で指定できる属性に parent_object, description を追加しました。

### 変更
- **【要注意】SSL関連のライブラリアップデートに伴い、リモート端末への Legacy TLS (v1.0/v1.1) での接続が非推奨になりました。**
    - 具体的には Windows 2008R2 など古い Windows に WinRS (HTTPS) で接続できなくなる可能性があります。
    - Kompira サーバ上の設定ファイル `/etc/crypto-policies/back-ends/opensslcnf.config` を編集して `TLS.MinProtocol = TLSv1.0` とすると、引き続き TLSv1.0 でも接続できるようになります（セキュリティ強度を下げることになるのでご注意ください）。
- チャネル型の message_queue に対するアクセスで pickle 化されたバイナリではなく通常のデータが参照できるようになりました。
- エクスポート時のファイル名が kompira_export-YYYYMMDD のように日付を含むようになりました。
- ディレクトリ形式エクスポートで添付ファイルデータを YAML ファイルに含めるのではなく実ファイルで出力するようになりました。
- 冗長構成セットアップ時の Corosync のトークンタイムアウトのデフォルトを 30 秒に変更しました。
- kompirad サービスの内部的な OS レベルのプロセス構成が変更になり、名称に kompirad を含むプロセスの数が増えました（プロセス数を監視している場合はご注意ください）。
- Django 3.2 系に対応するなど各種 Python ライブラリをアップデートしました。
    - amqp 2.6.x
    - apscheduler 3.9.x
    - cryptography 38.0.x
    - decorator 5.1.x
    - Django 3.2.x
    - django-filter 2.4.x
    - django-pgcrypto-fields 2.6.x
    - djangorestframework 3.13.x
    - django-select2 7.4.x
    - fabric 2.7.x
    - invoke 1.7.x
    - jinja2 3.0.x
    - markdown 3.3.x
    - mod-wsgi 4.9.x
    - paramiko 2.11.x
    - parsedatetime 2.6
    - psutil 5.9.x
    - psycopg2-binary 2.9.x
    - PyCryptodome 3.15.x
    - pyOpenSSL 22.1.x
    - python-daemon 2.3.x
    - pyyaml 6.x
    - requests 2.27.x
    - requests-credssp 2.0.x
    - structlog 21.5.x
    - tzlocal 4.x

### 修正
- source ライブラリの関数の呼び出しが稀にハングする場合がある問題を修正しました。
- User オブジェクトの enable_restapi に false を書き込んでも auth_token が null にセットされない問題を修正しました。
- チャネルオブジェクトに対するイベントジョブで ?? 記号を用いたガード条件を指定する（例：`<chan ?? pattern>`）と、異常終了する場合がある問題を修正しました。
- 同じジョブフローに対して REST API からパラメータを変えて連続的に実行するとパラメータが正しく渡らない問題を修正しました。
- 冗長構成のセットアップで pgsqlms の構成に失敗する場合がある問題を修正しました。
- export_dir と import_dir により添付ファイルの内容が破損してしまう問題を修正しました。
- クラウド上の一部の OS でオフラインパッケージの作成に失敗する問題を修正しました。
- setup_cluster.sh を実行するディレクトリによっては sync_master.sh, setup_utils.sh が更新されない問題を修正しました。
- --proxy オプション付きで setup_cluster.sh を実行すると冗長構成セットアップに失敗する問題を修正しました。
- 冗長構成で rabbitmq-cluster リソースエージェントの言語設定を修正しました。

### 改善
- マニュアル上でのインデックスおよびクロスリファレンスを改善しました。
- source ライブラリの呼び出しオーバーヘッドが軽減されました。

### 注意点
- v1.6.7 での SSL 関連のライブラリアップデートに伴い、Legacy TLS (v1.0/v1.1) での接続が非推奨になりました。Kompira サーバの OS 設定によっては、Windows 2008R2 など古い Windows に WinRS (HTTPS) で接続できなくなる可能性があります。
    - Kompira サーバに crypto-policies が導入されている場合、設定ファイル `/etc/crypto-policies/back-ends/opensslcnf.config` を編集して `TLS.MinProtocol = TLSv1.0` とすると、TLSv1 でも接続できるようになります。
- v1.6.7 にアップデートした後に、何らかの理由で v1.6.6 以前にダウングレードする場合は、事前に以下のコマンドを実行してセッション情報を削除してください。この手順を実行せずにダウングレードすると、内部エラーになりログインできない状態になる場合があります。その場合にも下記手順を実行してください。

    ```
    $ echo -e "from django.contrib.sessions.models import Session\nSession.objects.all().delete()" | /opt/kompira/bin/manage.py shell
    ```

- 過去のリリースでの注意点については「[Kompira Enterprise アップデート時の注意点](https://docbase.io/posts/2678628/sharing/c9fd6a81-53ed-4cd7-87b5-45042e71635c)」を参照してください。

---
## Ver.1.6.6 (2022/08/09)
### 新機能
- チャネルおよびメールチャネルにアクション機能を追加しました。
    - チャネルおよびメールチャネルがメッセージを受信したときに、ジョブフローを実行するなどの動作を指定できるようになりました。
    - チャネル型およびメールチャネル型に、以下のフィールドが追加されました。
        - アクション種別 (action_type)
        - アクションターゲット (action_target)
    - アクション種別でチャネルがメッセージを受信したときの動作を指定します。
        - 何もしない (NoAction)
        - アクションターゲットで指定したジョブフローを実行する (ExecuteJobflow)
            - そのジョブフローは第一パラメータに受信したメッセージが渡されて、チャネルオブジェクトの所有者をユーザとして実行されます。
    - チャネルにアクションが設定されていても、ジョブフローがチャネルを待ち受けている場合は、受信したメッセージはジョブフローが優先して受け取ります。

- プロセスがオブジェクトから起動された場合、該当するオブジェクトが格納されるようになりました。
    - プロセスオブジェクトに起動オブジェクトを示すフィールド `invoker` を追加しました。
    - 以下のように、プロセスの起動方法に応じて `invoker` に記録されるオブジェクトが変わります。
        - スタートアップジョブフロー実行 ⇒ スタートアップディレクトリ
        - フォームからジョブフロー実行 ⇒ フォームオブジェクト
        - テーブルからジョブフロー実行 ⇒ テーブルオブジェクト
        - チャネルのアクションによるジョブフロー実行 ⇒ チャネルオブジェクト
        - メールチャネルのアクションによるジョブフロー実行 ⇒ メールチャネルオブジェクト
    - 上記以外の、ジョブフローを直接実行した場合やスケジューラから起動された場合は、`invoker` には `null` が格納されます。

- 複数 SMTP サーバの設定に対応しました。
    - 新しい SMTP サーバ型 (/system/types/SmtpServer) が追加されました
    - SMTP サーバ型オブジェクトを格納する標準ディレクトリとして /system/smtp_servers が追加されました。
        - 標準の SMTP サーバ型オブジェクトとして /system/smtp_servers/Default が追加されました。
    - システム設定オブジェクトから SMTP サーバに関する設定項目が削除され、SMTP サーバ型オブジェクトを指定する設定項目が追加されました。
        - v1.6.5 以前から v1.6.6 以降へのバージョンアップ時に、システム設定オブジェクトから SMTP サーバの設定情報が /system/smtp_servers/Default に自動的に移行されます。
    - `mailto()` 組み込みジョブに SMTP サーバ型を指定するパラメータ `smtp_server` が追加されました。

- メール送受信において OAuth2 認証に対応しました。
    - メールチャネル型に以下のフィールドが追加されました。
        - OAuth2使用 (use_oauth2)
        - OAuth2プロバイダ (oauth2_provider)
        - リフレッシュトークン (refresh_token)
        - アクセストークン (access_token)
        - トークン有効期限 (token_expires_at)
    - OAuth2 認証を利用するには、ユーザー側で事前に利用する OAuth2 プロバイダに KE をアプリケーションとして登録しておく必要があります。詳しくは以下の資料を参考にしてください。
        - [Kompira Enterprise OAuth2 対応におけるメール送受信の設定方法](https://docbase.io/posts/2513028/sharing/4af461ba-3338-461e-adb4-611f7c482c70)

- メールチャネルおよびSMTPサーバに接続確認を行う機能を追加しました。
    - メールチャネル型および SMTP サーバ型のオブジェクト詳細画面に「接続テスト」ボタンが追加されました。
        - 「接続テスト」ボタンを押下すると、設定情報を用いて実際にサーバに接続できるか確認します。
        - メールチャネルではメールボックスの確認も行います。
    - それぞれの型オブジェクトに `conn_check` メソッドが追加されました。ジョブフローからも接続テストを行えます。

- メールチャネルでメール受信時にメールサーバからメールを削除しない機能を追加しました。
    - メールチャネル型に以下のフィールドが追加されました。
        - 受信モード (receive_mode)
    - 受信モードでメールチャネルがメールを受信するときの動作を以下から指定できるようになりました。
        - 全てのメールを受信して削除する (ReceiveAllAndDelete)
        - 未読のメールを受信して既読にする (ReceiveUnseenAndSetSeen)
            - ただし、ReceiveUnseenAndSetSeen はプロトコルが POP3 のときは指定できません。

- メールチャネル受信失敗時にジョブフローでの検知できるようにしました。
    - メールチャネルに対するイベントジョブのパラメータとしてキーワード引数 `detect_error` を指定できるようなりました。
    - メールチャネルに対するイベントジョブで以下のように `detect_error=true` を渡すと、設定の不備やメールサーバの障害などの理由によりメールのフェッチに失敗した場合やメールチャネルが無効化されている場合は、`$STATUS` を -1 にセットして、イベント待ちが直ちに終了します。
        - `<./メールチャネル: detect_error=true> =>> { if $STATUS == -1 | ... }`

- カスタムスタイル機能に対応しました。
    - メニューバーの背景色や文字色、メイン画面部分の背景色などをカスタマイズできるようになりました。
    - 新しいカスタムスタイル型 (/system/types/CustomStyle) が追加されました。
    - システム設定に新しい項目「カスタムスタイル」を追加しました。ここで選択したカスタムスタイルが適用されるようになりました。
    - いくつかの標準のカスタムスタイル設定が (/system/styles) に追加されました。
        - デフォルト、ダークモード、プリティピンク、スカイブルー、エメラルドグリーン、ライトパープル

- システム設定にブランドタグ (brandTag) を追加して、ブランド表記をカスタマイズできるようになりました。
    - メニューバー左上などにあるブランド名表記 `Kompira` に続けて表示されるブランドタグを文字列で設定できます。
    - ブランドタグが指定されている場合は、ブランド名のあとに空白をあけて `[` と `]` に挟んで表示されます。

- プロセス詳細画面で以下のキー操作に対応しました。
    - ``F6``：プロセスの中止（確認ダイアログが表示されます）
    - ``F7``：プロセスの停止
    - ``F8``：プロセスの続行
    - ``CTRL-[``：前のタブに切り替え
    - ``CTRL-]``：次のタブに切り替え
    -  ``a``： コンソールタブまたは結果タブでのテキスト選択切り替え

### 変更
- **【重要】冗長構成のアップデート手順が変更になりました。**
    - 以下のように、アップデート後に pcs cluster start 手順が不要になりました。詳細についてはマニュアル「1.9.3. アップデート」を参照してください。
    - 両系停止アップデート手順（切り替えを伴わない）
        - スタンバイ系を停止 (pcs cluster stop)
        - アクティブ系を停止 (pcs cluster stop --force)
        - アクティブ系をアップデート (./install.sh)
        - スタンバイ系をアップデート (./install.sh)
    - 片系停止アップデート手順（切り替えを伴う）
        - スタンバイ系を停止 (pcs cluster stop)
        - スタンバイ系をアップデート (./install.sh)
        - アクティブ系を停止 (pcs cluster stop)
        - 旧アクティブ系をアップデート (./install.sh)
- Favicon 画像を SVG 形式に変更しました。
- メニューバーにブランドロゴ画像を表示するようになりました。
- ログイン画面/ログアウト画面のデザインを見直しました。
- メールチャネルについて、いくつかのフィールドの並び順を変更しました。
- いくつかの型オブジェクトでポート番号に指定できる値を 0 から 65535 の範囲に制限しました。
- プロセス詳細画面のコンソールバッファの高さをウインドウサイズに合わせて自動調整するようにしました。

### 修正
- チェックポイントモードで再開したプロセスで print() によるコンソール出力が出来なくなる場合がある問題を修正しました。
- 設定メニューの項目が空になる場合がある問題を修正しました。
- Windows へのファイル送信(PUT)でサイズが大きい場合に失敗する問題を修正しました。
- Windows からのファイル転送(GET)に時間がかかる問題を改善しました。
- 依存フィールドになっている Enum 型フィールドで表示名が表示されない問題を修正しました。
- 冗長構成のアップデート時に rabbitmq.conf をシングル構成用に書き換えてしまう問題を修正しました。
- プロセス詳細画面が正常にリフレッシュできていない場合がある問題を修正しました。
- 冗長構成でパスワードフィールド用の secret key が同期されない問題を修正しました。
- systemctl stop kompirad (または kompira_jobmngrd) でサービスの状態が failed にならないように暫定対処しました。

### 改善
- データベースアクセス方法を改善して、ブラウザ画面表示や一部のジョブフロー動作の応答性を向上しました。
- マニュアル - 管理ガイド
    - 「ノードの設定」にローカルノードについての説明を追加しました。
    - 「ノードの設定」のネットワーク機器の制限事項の説明に一部補足を加えました。
    - 「Kompira画像ファイル」に Kompira で利用する画像ファイルの説明を追加しました。
- マニュアル - 操作ガイド
    - 「基本的な操作方法」を追加して、ログインとログアウト操作、メニュー操作、キーボード操作の説明を加えました。
    - 「Kompiraオブジェクト」の一覧表を /system/types に定義されいてる順に並べ替えました。
    - 「ディレクトリ」でディレクトリで行える各操作について詳しく記述しました。
    -  「フォーム」に新規にフォームについての説明を追加しました。
- マニュアル - Kompiraチュートリアル
    - 「外部にアクセスする」で mailto() に送信元を指定するパラメータを from_user から from に修正しました。
    - 「外部にアクセスする」でメールを送信する際の警告部分を内容を現バージョンに合わせて書き換えて注釈としました。
- マニュアル - Kompira ジョブフロー言語リファレンス
    - 「字句構造」に、ジョブフローとして記述できるのは最大 65536 文字であることを追記しました。
    - 「結合子」に、1つのジョブフロー式で結合できるジョブの最大数は 4096 個であるこをと追記しました。
- マニュアル - Kompira 標準ライブラリ
    - 「組み込み関数」に各関数が返す結果の型を追記しました。
    - 「組み込み型オブジェクト」でいくつかの型オブジェクトの型名表記に抜けがあったのを修正しました。

### 注意点
- v1.6.4 ～ v1.6.5 で冗長構成を新規に構築した環境では、パスワードフィールド用の secret key が同期されないという不具合が見つかっております。これに該当する場合は、フェイルオーバーした際に新たなアクティブ系でパスワードフィールドの値が読み込めなくなる、といった問題が生じます。ご利用中の冗長構成の環境で、以下のシークレットキーファイルの内容が同一であるか確認してください。内容が同一であれば、不具合は生じていません。

   ```
   /var/opt/kompira/.secret_key
   ```

    シークレットキーファイルの内容が異なる場合は不具合が生じているため、v1.6.6 にアップデートする前に復旧させる必要があります。詳しくは以下の資料を参考にしてください。
    - [[KE16不具合] 冗長構成でパスワードフィールド用の secret key が同期されない](https://docbase.io/posts/2531947/sharing/97a1c155-edc4-4157-8465-3313243d8dad)

- 冗長構成を v1.6.5 までにアップデートしたことがある環境では、rabbitmq-server の設定ファイルである /etc/rabbitmq/rabbitmq.conf がシングル構成用に書き換えられている場合（内容が1行になっている場合が該当します）があります。そうした環境でアップデートのために install.sh を実行したとき、その最後に以下のような警告メッセージが表示されるようになりました。

    ```
    [2022-07-22 12:00:00] WARN: !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: CORRUPT CONFIG DETECTED! (/etc/rabbitmq/rabbitmq.conf)
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: YOU CAN RESTART THE CLUSTER AS IS.
    [2022-07-22 12:00:00] WARN: HOWEVER THE FOLLOWING MEASURES ARE RECOMMENDED.
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: Please copy /etc/rabbitmq/rabbitmq.conf.new to /etc/rabbitmq/rabbitmq.conf
    [2022-07-22 12:00:00] WARN: before restarting the cluster.
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN:   # cp -f -S .old -b /etc/rabbitmq/rabbitmq.conf.new /etc/rabbitmq/rabbitmq.conf
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: CAUTION: PLEASE COPY ON EACH NODES WHEN BOTH CLUSTERS ARE STOPPED.
    [2022-07-22 12:00:00] WARN: 
    [2022-07-22 12:00:00] WARN: !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    ```

    この場合、このまま利用することも可能ですが、冗長構成用に改めて用意した設定ファイル（setup_cluster.sh 実行時のものと同様です）に置き換えることを推奨します。メッセージに表示されているように、以下のコマンドをそれぞれのノードで実行してください。

    ```
    # cp -f -S .old -b /etc/rabbitmq/rabbitmq.conf.new /etc/rabbitmq/rabbitmq.conf
    ```

    ただし、設定ファイルをコピーする際は両系のクラスタが停止している状態で実施する必要がありますのでご注意ください。手順的には以下を参考にしてください。

    1. 両系を停止する（スタンバイ系を先に停止させて、後に、アクティブ系を停止させてください）
    2. 設定ファイルをコピーコマンドなどで置き換えてください。
    3. 両系を再開する（アクティブ系を先に再開させて、後に、スタンバイ系を再開させてください）

- v1.6.4 から添付ファイルがデータベースに保存されるようになりました。v1.6.3 以前から v1.6.4 以降にアップデートする場合は、v1.6.4 のリリースノートの注意点を参照してください。

---
## Ver.1.6.5 (2022/05/09)
### 新機能
- プロパティを一括変更する機能を追加しました。
    - ディレクトリまたはテーブル画面で、複数オブジェクトを選択した状態でプロパティの編集ができるようになりました。
        - プロパティ編集用のダイアログが表示されて、所有者・ユーザパーミッション・グループパーミッションについて設定できます。適用ボタンを押下すると、選択した複数のオブジェクトに設定した属性値が適用されます。
        - このとき、変更を適用したい項目をチェックボックスで選択することができます。デフォルトではオンになっています。すべてのチェックを外して適用した場合は、更新日時だけ更新されます。
        - 編集ダイアログに初期表示されるのは、親オブジェクトの属性値であることに注意してください。
    - 単一のディレクトリまたはテーブルに対するプロパティ編集画面に、「変更を子孫オブジェクトにも適用する」オプションが追加されました。
        - 所有者・ユーザパーミッション・グループパーミッションについて、それぞれの変更を子孫オブジェクトにも適用するかをチェックボックスで選択することができます。デフォルトではオフになっています。
    - 表示名および説明については、一括変更の対象外となります。
    - 変更を適用する対象のオブジェクトに、操作しているユーザにプロパティを更新する権限が無いオブジェクトが存在した場合は、そのオブジェクトへのプロパティ変更はスキップされます。
    - 変更を適用する対象のオブジェクト数が多い場合は、適用に時間がかかる場合がありますのでご注意ください。
    - 詳細については、マニュアルの「2.3.2.オブジェクトのプロパティ」「2.4.1.ディレクトリ」を参照してください。
- コンソールに実行したコマンドラインなどジョブ情報を表示する機能に対応しました。
    - 以下の場面で、実行したコマンドラインやジョブの情報をコンソールに表示できるようになりました。
        -  実行ジョブでコマンドを実行
        - 実行ジョブでスクリプトジョブを実行
        - セッションブロックの開始
        - 再起動ジョブの実行
    - システム設定オブジェクト (/system/config) に表示可否および表示形式を設定する項目が追加されました。
        - コマンド表示可否 (showCommandEnabled)
        - コマンド表示形式 (showCommandFormat)
    - 詳細については、マニュアルの「2.7.4. システム設定」「2.7.4.1. コマンド表示形式」を参照してください。
- コマンド実行時のコンソール出力を制御する機能に対応しました。
    - ジョブフローでコマンドやスクリプトジョブを実行中に得られた標準出力や標準エラー出力、およびセッションブロックを実行中に得られた出力について、コンソールに表示するか、どの程度表示するかを制御できるようになりました。
    - システム設定オブジェクト (/system/config) にコンソール出力制御を設定する項目が追加されました。
        - 標準出力表示可否 (showStdoutEnabled)
        - 標準出力表示フィルタ (showStdoutFilter)
        - 標準エラー出力表示可否 (showStderrEnabled)
        - 標準エラー出力表示フィルタ (showStderrFilter)
        - セッション表示可否 (showSessionEnabled)
        - セッション表示フィルタ (showSessionFilter)
    - 詳細については、マニュアルの「2.7.4. システム設定」「2.7.4.2. コンソール表示フィルタ」を参照してください。

### 変更
- Dataテーブルの id を integer 型 (32bit) から biginteger 型 (64bit) に拡張しました。
- テーブルからのフォーム実行で表示されるダイアログの幅を大きくしました。
- 視認性改善のためボタンのスタイル変更と、一部のボタンのテキスト表記を改善しました。
- 修正対応のために、ジョブフロー型に「コンパイル日時(compiledDatetime)」フィールドが追加されました。ただしこれは不可視なフィールドであり、ユーザが確認したり編集したりすることはできません。

### 修正
- Windows 連携において稀に内部エラーが発生する場合がある問題を修正しました。
- Windows に対するスクリプトジョブ実行でリモートに転送したスクリプトが残る場合がある問題を修正しました。
- タイムスタンプが変更されていない場合でもジョブフロー再コンパイル時にはキャッシュリロードするように修正しました。
- オブジェクトのプロパティ保存時にリダイレクトループすることがある問題を修正しました。
- 特権ユーザが他ユーザが所有するオブジェクトのプロパティを変更できなくなってしまう問題を修正しました。
- プロパティ編集でグループパーミッションだけを空にして保存するとバリデーションエラーとなる問題を修正しました。
- ユーザ操作に対して内部エラーが発生したときに監査ログが記録されない場合がある問題を修正しました。

### 注意点
- v1.6.4 から添付ファイルがデータベースに保存されるようになりました。v1.6.3 以前から v1.6.4 以降にアップデートする場合は、v1.6.4 のリリースノートの注意点を参照してください。

---
## Ver.1.6.4.post2 (2022/03/31)
### 修正
- 古い Windows と連携時に CredSSP 認証する場合に失敗することがある問題を修正しました
- RHEL8.5 で ipcalc コマンドが存在せずに setup_cluster.sh に失敗する問題を修正しました。

### 注意点
- v1.6.4 から添付ファイルがデータベースに保存されるようになりました。v1.6.3 以前から v1.6.4 以降にアップデートする場合は、v1.6.4 のリリースノートの注意点を参照してください。

---
## Ver.1.6.4.post1 (2022/02/10)
### 変更
- パッケージから LICENSE.pdf ファイルの同梱を取り除き README.md からのライセンス利用規約のリンクを修正しました。

### 修正
- find() メソッドで order_by の指定方法によってエラーになる場合がある問題を修正しました。
- REST API で設定オブジェクトのデータ(data属性)を PUT/PATCH で更新できない問題を修正しました。
- RSAキー認証によるSSHアクセスに失敗する場合がある問題を修正しました。
- コンソールのメールアドレス出力時に>が末尾に含まれていると余分なセミコロンが表示される問題を修正しました。

### 改善
- マニュアル - Kompira 標準ライブラリ
    - ドキュメントに find() メソッドでの order_by, offset, limit パラメータの説明を追加しました。
    - ドキュメントにディレクトリ型およびテーブル型での orderBy, pageSize フィールドの説明を追加しました。

### 注意点
- v1.6.4 から添付ファイルがデータベースに保存されるようになりました。v1.6.3 以前から v1.6.4 以降にアップデートする場合は、v1.6.4 のリリースノートの注意点を参照してください。

---
## Ver.1.6.4 (2022/01/21)
### 新機能
- NW機器との連携 (SSH/TELNET) に対応しました。
    - ノードの種類を示す「ノード種別」型オブジェクトが新たに追加されました。
        - システム標準のノード種別は /system/nodetypes で提供します。
    - NW機器についてもノード種別の一覧に加えていますが、動作確認済みの機種はその一部となります。
        - v1.6.4 時点で動作確認済みのNW機器は以下のとおりです。
            - Cisco IOS (SSH, TELNET): Cisco 892J, Cisco CSR1000V
            - Cisco ASA (SSH): Cisco ASA5505
            - Yamaha (SSH, TELNET): Yamaha RTX1200
            - Juniper ScreenOS (SSH): Juniper SSG5
            - HP Procurve (SSH): ProCurve 2510G
    - NW機器との連携についていくつか制限事項がありますのでご注意ください。
        - コマンドジョブではコマンドの成否は判別できません。ログイン成功した場合は、実際のコマンド成否にかかわらず $STATUS は常に 0 になります。エラー判定が必要な場合は、標準出力にエラーメッセージが含まれていないか、などをジョブフローで判定する必要があります。
        - 標準エラー出力には対応していません（内部的には PTY モードと同様になっており、出力はすべて標準出力として取得されます）。
        - 制御変数によるシェルの指定や実行ディレクトリの指定には対応していません。
        - スクリプトジョブ、再起動ジョブには対応していません。
        - 一部の機種 (Cisco IOS, Cisco ASA) では PUT/GET によるファイル転送に対応していますが、単一ファイルの転送のみが可能です。ワイルドカードの指定や再帰的なファイル転送には対応していません。
    - 「ノード情報」型オブジェクトが拡張されて、上記の「ノード種別」を選択できるようになりました。
        - ノード種別を選択すると、そのノード種別で対応する接続種別（SSH か TELNET か等）を選択できるようになります。
- 添付ファイルのデータベースへの保存に対応しました。
    - アップロードファイルサイズの制限を1GBに引き上げました。
    - アップロード中にプログレスバーが表示されるようになりました。
    - 制限を超えるサイズのファイルを添付しようとしたときにエラーが表示されるようになりました。
    - エクスポートおよびインポートで添付ファイルも処理されるようになりました。
        - JSON 形式では添付ファイルのデータは BASE64 エンコードで表現されます。
- フィールド修飾子を拡張しました。
    - Enum/Object フィールドのフィールド修飾子に以下の機能が加わりました。
        - 依存フィールドの指定に対応しました（他の項目の入力値に合わせて、選択肢を切り替えられます）。
        - SWITCH-CASE 条件の指定に対応しました（他の項目の入力値のパターンに応じて、選択肢を切り替えられます）。
        - オブジェクトフィールドからの選択肢読み込みに対応しました（他のオブジェクトのフィールド値を読み込んで選択肢とすることができます）。
    - Objectフィールドの修飾子で絞り込みと並び順軟に指定できるようになりました。
        - `filter` 修飾子でディレクトリオブジェクトの `find()` メソッド同様の絞り込みを指定できるようになりました。
        - `order_by` 修飾子で並び順を指定できるようなりました。
    - 詳細についてはマニュアル「5.2.2. フィールド修飾子」を参照してください。

### 変更
- 「ノード種別」型オブジェクト `/system/types/NodeType` を追加しました。
- 「ノード情報」型オブジェクトの定義に以下の変更が加わりました。
    - 先頭に「ノード種別」フィールドが追加しました。
    - 「接続種別」フィールドの位置が「ノード種別」フィールドの次になるように移動しました。
    - 「接続種別」フィールドは「ssh または winrs」の選択肢でしたが、選択した「ノード種別」に応じて切り替わるようになりました。
- Windows ノードの接続種別が4種類から選択できるようになりました。
    - `windows/https`: 最も安全ですが、サーバ側に正式な SSL 証明書の導入が必要です。
    - `windows/https-ignore-validation`: サーバ証明書の検証エラーを無視するため、自己署名証明書が利用可能です。
    - `windows/http`: HTTP通信ですがメッセージは暗号化されます。
    - `windows/http-unencrypted`: HTTP通信でメッセージは暗号化されません（非推奨）。
        - サーバ側で事前に非暗号化通信を許可する設定（非推奨）が必要になります。
    - 互換性のため従来の接続種別 ``winrs`` も利用できます。ただし、この場合はポート番号が指定されているかどうかで、利用するプロトコルが切り替わります。ポート番号として 5986 または 443 が指定されている場合は HTTPS が、5985 または 80 が指定されている場合は HTTP が利用されます。ポート番号が省略されている場合は HTTPS 接続を試みます。
- ジョブフローで指定できる接続種別 `__conntype__` に指定できる値が追加されました。
    - Windowsノード:
        - HTTPS通信: `windows/https`, `windows/https-ignore-validation`
        - HTTP通信: `windows/http`, `windows/http-unencrypted`
    - NW機器ノード:
        - Cisco IOS: `cisco_ios/ssh`, `cisco_ios/telnet`
        - Cisco ASA: `cisco_asa/ssh`
        - Yamaha: `yamaha/ssh`, `yamaha/telnet`
        - Juniper ScreenOS: `juniper_screenos/ssh`
        - HP ProCurve: `hp_procurve/ssh`
- httpd のログについて日次で30個分ローテートする設定に変更しました。
- ジョブフロー上でのファイル型から `path` フィールドは廃止されました。
- 冗長構成で lsyncd/rsyncd サービスが不要になりました。

### 修正
- 型オブジェクトのフィールド修飾子で型の合わないデフォルト値を指定したときに不正に適用される場合がある問題を修正しました。
- 冗長構成でも httpd のログローテートができるように修正しました。
- テーブル画面の検索で同一オブジェクトが複数回表示される場合がある問題を修正しました。
- ディレクトリの find() メソッドで検索値を配列で指定した場合に期待した結果が得られない場合がある問題を修正しました。
- ローカル接続で shell に空文字列を指定すると Permission denied が発生する問題を修正しました。
- パターンと文字列を類似比較演算子で評価すると異常終了する問題を修正しました。
- プロセス詳細画面でジョブフロー終了時のプロセスステータスなど一部の文字列が翻訳されていない問題を修正しました。
- テーブルに関連付けたフォームの配列/辞書フィールドで操作の削除ボタンが消える問題を修正しました。
- フォームのURLに Array\<Object\> に渡すパラメータを渡すと 500 内部エラーが発生する問題を修正しました。
- テーブルの関連オブジェクトのフォームのEmailフィールドでaやcといった文字が入力できない問題を修正しました。
- REST API で添付ファイルフィールドのデータ登録・更新ができない問題を修正しました。
- Object フィールドの選択肢がタイムアウトでエラーになる問題を修正しました。
- ディレクトリの find() メソッドでオブジェクトを検索するときに内部エラーになる場合がある問題を修正しました。
- RHEL8環境でオフラインパッケージが作成できない場合がある問題を修正しました。
- REST-API でテーブルへのオブジェクト作成ができない問題を修正しました。
- name パラメータ無しで Directory オブジェクトに POST すると 500 エラーになる問題を修正しました。
- ファイル配列/辞書にファイルが添付されている設定オブジェクトをエクスポートした時にデータが空になる問題を修正しました。

### 改善
- マニュアル（共通）
    - PDF 形式のマニュアルで一部の表が崩れて表示されていたのを改善しました。
- マニュアル - 管理ガイド
    - オフラインインストール手順の説明を追加しました。
    - 追加されたノード種別や接続種別などの説明を追加しました。
    - ログファイルに関する情報（標準のログローテート設定など）を追加しました。
    - 冗長構成のアップデート手順の説明を追加しました。
- マニュアル - 操作ガイド
    - プロセス詳細画面の結果タブと設定タブの説明を追加しました。
- マニュアル - Kompira 標準ライブラリ
    - フィールド修飾子の説明を追加しました。
- マニュアル - Kompira REST API リファレンス
    - 添付ファイルフィールドに対する API を更新しました。

### 注意点
- v1.6.4 から添付ファイルがデータベースに保存されるようになり、また合わせてサイズ制限が緩和されました。データベース上では添付ファイルの実サイズより大きい容量を必要とするため、大きな添付ファイルを扱う場合はディスクの空き容量にご注意ください。
- v1.6.4 からサーバ上に添付ファイルの実体は保持しなくなりますので、サーバ上に添付ファイルの実体が存在することを前提としたジョブフローなどは正常に動作しなくなります。
- v1.6.3 以前からアップデートした場合、既存の添付ファイルは kompirad 起動時に自動的にデータベースに保存されます。そのため、添付ファイルの数が多い場合は起動に時間がかかる場合があります。また、データベース保存に移行した後も、添付ファイルに対応するサーバ上の実ファイルはそのまま残っていますので、不要な場合は手動で `/var/opt/kompira/upload` を削除してください。
- 冗長構成を v1.6.3 以前から v1.6.4 以降にアップデートした場合、pacemaker 配下で lsyncd サービスが動作する設定のままとなっています。v1.6.4 環境で lsyncd が動作していても影響はありませんが、lsyncd サービスを停止させる場合は冗長構成のアップデートが正常に終えたあとに、root 権限で以下のコマンドを実行してください。

    ```
    # pcs resource delete res_lsyncd
    ```

---
## Ver.1.6.3 (2021/10/29)
### 新サポート環境
- インストール対象の OS として CentOS Stream 8 に対応しました。
- AWS 環境での冗長構成に対応しました。
    - 「[KE16] AWS での冗長構成の構築ガイドライン」を以下で公開しました。
        - https://docbase.io/posts/2109239/sharing/338a5440-764e-43d6-93ea-a42ed365ef01

### 新機能
- 監査ログ機能に対応しました。
    - 新たに `/var/log/kompira/audit-*.log` というログが記録されるようになります。
    - 監査ログのファイル形式は JSON です。
    - 詳細はマニュアル「1.10. 監査ログ管理」を参照してください。
- システムパッケージ情報を閲覧できるようになりました。
    - Kompira 上の `/system/packages/` 配下のページで、システムにインストールされているパッケージを確認できます。
    - 現時点では Python 用 PIP パッケージおよび、Web 用パッケージを確認できます。
    - 詳細はマニュアル「1.11. システムパッケージ管理」を参照してください。
- 仮想オブジェクトに対する `find` メソッドが追加されました。
    - ジョブフローからプロセスなど仮想オブジェクトに対して、フィルタ条件を指定して絞り込んで一覧を取得できるようになりました。
    - 詳細はマニュアル「5.4. 特殊オブジェクト」の各オブジェクトごとの、`find` メソッドの説明を参照してください。
- `upload()` 組み込みジョブで `Array<File>` や `Dictionary<File>` 型フィールドにファイルをアップロードできるようになりました。
    - 詳細はマニュアル「5.1.1. ローカル組み込みジョブ」の `upload()` 組み込みジョブの説明を参照してください。
- プロセス管理コマンド `/opt/kompira/bin/manage.py process` を追加しました。
    - Kompira サーバのコンソール上でプロセスオブジェクトの操作（一覧表示、削除、中止、停止、続行）が行えます。
    - 詳細はマニュアル「2.5.3. 管理コマンドによるプロセス操作」を参照してください。

### 変更
- 管理コマンド `/opt/kompira/bin/manage.py` を実行できるユーザを、サーバ上の `root` ユーザおよび `kompira` グループに所属するユーザに限定するようにしました。
    - 上記に該当しない一般ユーザでは実行できなくなりましたのでご注意ください。
- ライブラリ呼び出し時のメモリサイズ・ファイル数上限をデフォルトで無制限に変更しました。
    - 従来は処理プロセスに対して、デフォルトでメモリサイズ 4GB・ファイル数 128 という上限を設定していました。

### 修正
- オブジェクト検索画面で検索条件に空白を含むときに表示件数を指定すると空白文字が+に置き換わる問題を修正しました。
- 冗長構成でジョブフロー数が多い状態でKompiraをアップデートインストールするとkompiradが起動しなくなる場合がある問題を修正しました。
    - kompirad 起動時のジョブフロー一括コンパイルを廃止して、ジョブフロー実行時に必要に応じてジョブフローオブジェクトを再コンパイルするようにしました。
- winrs でのコマンド実行時に引用符を含んでいるとエラーになる場合がある問題を修正しました。
- コマンド失敗時に終了ステータスコードが `$STATUS` にセットされず常に1となる問題を修正しました。
- 冗長構成で kompira アップデート後に `setup_cluster.sh` を実行した時にリソース設定が更新されない問題を修正しました。
- オフラインパッケージの作成およびオフラインインストールに失敗する場合がある問題を修正しました。
- オブジェクトに対する REST-API でパーミッションがチェックされない場合がある問題を修正しました。
- 添付ファイルフィールドをAPIでGETしようとすると内部エラーが発生する問題を修正しました。

### 改善
- ジョブフローキャッシュ機構を導入して、ジョブフロー呼び出し時間を改善しました。
- Configオブジェクトの「設定の編集」時のパーミッションエラーメッセージとマニュアルの記載について、分かりやすく改善しました。
- マニュアルを改善しました。
    - 冗長構成の管理コマンドの出力表示を更新しました。
    - マニュアルの使用ポート一覧の冗長構成の記載を現状に合わせて更新しました。
- 画面デザインを改善しました。
    - フィールドと help_text の間に余計な空白が空いてしまうのを修正しました。

### 注意点
- CentOS 7 環境における冗長構成アップデートの注意点
    - 対象：v1.6.0～v1.6.2.post1 から v1.6.2.post2 以降へのアップデート
    - 詳細については以下をご確認ください。
        - https://docbase.io/posts/2118544/sharing/aaab9c34-93a2-4af6-85e0-7b50cef07d3a

---
## Ver.1.6.2.post7 (2021/08/31)

### 修正
- メールチャネルで最後に受信したメールをイベントジョブで受け取れない場合がある問題を修正しました。
- メールチャネルでのメール受信やスケジュールの起動ができない問題を修正しました。
- print組み込み関数で'delim'以外のキーワード引数が渡されたらエラーメッセージを出してSTATUS=1を返すように修正しました。
- 関数呼び出しで runtime というキーが含まれたキーワード引数を渡すとエラーとなる問題を修正しました。
- updateメソッドで「user」という名前のフィールドの値を更新しようとするとエラーとなる問題を修正しました。

### 改善
- sourceライブラリの呼び出しのオーバヘッドを削減しました。

---
## Ver.1.6.2.post6 (2021/07/30)

### 変更・追加
- manage.py のコマンドに compile_library を追加しました (Ver.1.5からの移植) 。
- 制御変数 `__use_cache__` を追加しました。接続キャッシュの利用を制御できるようになりました。
- winrs 接続に関しては接続キャッシュを利用しないように変更しました（安定性を欠く場合があり速度優位性も認められないため）。

### 修正
- kompira_jobmngrd の動作に kompira.conf の設定を反映できない項目がある問題を修正しました。
- チャネルリストでのイベントジョブで要素数が多いときに内部エラーが発生することがある問題を修正しました。
- 空の修飾子の enum 型フィールドを持つオブジェクトを作成すると内部エラーになる問題を修正しました。
- メッセージを含んだチャネル（やバイナリ辞書・配列フィールドを含んだオブジェクト）がコピーできない場合がある問題を修正しました。
- バイナリフィールドで不正な入力値を保存しようとすると他のバイナリフィールドの入力フォームの値がクリアされてしまう問題を修正しました。
- バイナリ辞書・配列フィールドの値が表示されない問題を修正しました。
- `__sudo__=true` のローカル実行コマンドジョブを中止したときに以後のコマンドジョブの実行に失敗する場合がある問題を修正しました。
- SSH の exec リクエストに対応していない機種とセッションジョブで連携できない問題を修正しました。
- LANG が C.UTF-8 の環境で install.sh に失敗する問題を修正しました。

### 改善
- プロセスオブジェクト属性の記載漏れ(exit_status, result, error)をマニュアルに追記しました。
- 冗長構成セットアップ/インストールスクリプトのヘルプメッセージとマニュアルの記述を更新しました。

---
## Ver.1.6.2.post5 (2021/06/30)

### 変更
- 同梱の Kompira利用規約 (LICENSE.pdf) を更新しました。

### 修正
- 文字列系フィールドを保存したときに前後の空白が削除されてしまう問題を修正しました。
- ローカルコマンド実行時に適切にタイムアウトしない場合がある問題を修正しました。
- API/ブラウザ操作で maximum recursion depth exceeded が発生することがある問題を修正しました。
- ディレクトリ一覧画面から表示名での検索ができない問題を修正しました。
- 添付ファイルの名前にマルチバイト文字が含まれているとダウンロード時に期待したファイル名にならない問題を修正しました。
- 冗長構成でマスタ側サーバを強制終了するとマスタを正しくフェイルバックできない問題を修正しました。
    - 冗長構成をご利用中のお客様は、下記の補足を参考に構成パラメータの変更をご検討ください。

### 改善
- ファイルが添付されていないファイルフィールドをダウンロードしたとき 204 NoContent を返すようにしました。

### 補足
#### 冗長構成の構成パラメータ変更について【重要】
本リリースにより冗長構成の初期セットアップ時に適用される構成パラメータを変更しています。既存の冗長構成においても同様の構成パラメータ変更を適用することを推奨します。アクティブ系の Kompira サーバ上で以下のコマンドを実行してください。

```
# pcs resource update res_pgsql op demote on-fail=restart
# pcs resource update res_pgsql op stop on-fail=ignore
```

上記のパラメータ変更により、冗長構成における以下の問題を解消します。
- Kompiraサーバがクラッシュして、（PostgreSQLのが正しく停止しなかった状態で）そのサーバが再起動してクラスタに参加しようとした時に、アクティブ側の稼働を停止してしまう問題を解消します。（op demote on-fail=restart による解消）
- PostgreSQLプロセスが単独でクラッシュした場合、フェールオーバに失敗する問題を解消します。（op stop on-fail=ignore による解消）

---
## Ver.1.6.2.post4 (2021/04/27)

### 修正
- winrs で内部エラー発生時にコマンドジョブが終了しない場合がある問題を修正しました。
- 読み込み権限のあるフォームオブジェクトを閲覧できない場合がある問題を修正しました。
- CentOS8.3での冗長構成のセットアップに失敗する問題を修正しました。
- プロセス一覧取得 API で attrs パラメータによる属性指定ができない問題を修正しました。
- コマンド実行に伴い kompira_jobmngrd が多数のファイルをオープンしている問題を修正しました。
- APIで仮想オブジェクトの詳細情報に認証トークン無しでアクセスできてしまう問題を修正しました。
- チャネルからのデータ受信時に$STATUS=0にセットされない問題を修正しました。

### 改善
- リモートジョブでの標準入力の処理を見直して負荷を軽減しました。

---
## Ver.1.6.2.post3 (2021/04/08)

### 変更
- REST-API で JSON 形式パラメータが厳密にエスケープされていなくてもエラーにならないようにしました。
- json_dump, json_load でいくつかオプションを指定できるようになりました。
- オンラインエディタのメニューやジョブフローパラメータ入力欄など、いくつかの画面のスタイルを改善しました。
- サーバ上の kompira/static 配下のディレクトリ構成を見直しました。

### 修正
- manage.py process コマンドでオプションによっては例外が発生する問題を修正しました。
- 型オブジェクトの extend フィールドで拡張モジュールを指定しても機能しない問題を修正しました。
- ライブラリローダが無限再帰してインポートできない場合がある問題を修正しました。
- ライブラリで map() の結果を返すと `"<map object at ...>"` といった文字列が返ってしまう問題を修正しました。
- Configオブジェクトの型フィールドの名称によってはKompiraオブジェクトの属性値を上書きしてしまう問題を修正しました。
- `"Meta"` などいくつかの文字列がフィールドの名前として使えない問題を修正しました。
- 長いコマンドラインやスクリプトの引数を渡せるようにする
- サイズの大きいスクリプトジョブが実行できない問題を修正しました。
- Group一覧取得API／User一覧取得APIがエラーになる問題を修正しました。
- 日本語を含む ps1 スクリプトのスクリプトジョブ実行に失敗する問題を修正しました。
- 空文字列のコマンドジョブを実行すると応答がなくなる問題を修正しました。
- Time型フィールドの値が編集画面を開くと空になってしまう問題を修正しました。
- CentOS8/RHEL8 においてアップデートに失敗する問題を修正しました。

---
## Ver.1.6.2.post2 (2021/02/15)

### 変更
- 同梱のライセンス利用規約ファイルを ver.8.0 に更改
- CentOS7/RHEL7 においても新しい rabbitmq-server がインストールされるようにしました

### 修正

- オブジェクトに拡張子をつけてブラウザアクセスすると内部エラーとなる問題を修正しました。
- オブジェクトのフィールドを画面上から検索するとInternal Server Errorになる問題を修正しました。
- ログイン画面のパスワード入力欄に autocomplete="off" 属性を付けるようにしました。
- オンラインヘルプマニュアルのデッドリンクを修正しました。
-  pip が古すぎてインストールに失敗する問題を修正しました。
- Netmiko でプロンプトを誤認識してコマンド実行が完了しない場合がある問題を修正しました。
- Netmiko で UTF-8 エンコードでない機器に接続したときにデコードエラーが生じる場合がある問題を修正しました。
- インストール時に自動生成される秘密鍵に特殊記号が含まれないようにしました。
- コマンドの出力が多いときにコンソールに表示されない場合がある問題を修正しました。
- 標準エラー出力の量が多いとジョブマネージャとの接続が切れてしまう問題を修正しました。
- コマンド実行結果の標準エラー出力をバイナリで受信するとプロセスが完了しない問題を修正しました。
- /config, /task, /incident, /scheduler, /process をインポート時の保護領域に追加しました

---
## Ver.1.6.2.post1 (2021/01/08)

### 修正
- 冗長構成で v1.6.2 に install.sh のみでアップデートすると暗号化フィールド用のシークレットキーファイルが同期されない問題を修正しました。
- v1.6.2にアップデートすると Array<Password> と Dicrionary<Password> フィールドのデータが空になる問題を修正しました。
- 冗長構成で v1.6.2 にアップデート後に kompirad が起動できない問題を修正しました。
- CentOS7系の冗長構成で非ASCII文字をパスに含む添付ファイルオブジェクトを表示できない問題を修正しました。
- 配列フィールドを10個以上にして保存すると2つ目以降のフィールドが消えてしまう問題を修正しました。

---
## Ver.1.6.2 (2020/12/28)

### 追加
- kompira_sendevt/kompira_jobmngrdインストール時のガードを追加しました
- ファイル配列とファイル辞書のフィールドをサポートしました
- ライセンスファイルを更新するlicense_update管理コマンドを追加しました
- スケジュールのコピーに対応しました
- urlopenのdataパラメータでbinaryに対応しました
- sleep関数でFloatも受け付けるように拡張しました

### 変更
- エクスポートしたファイルのインポート時にデフォルトでシステム領域を保護するように変更しました
- 仮想オブジェクト型などシステム内部利用の型のオブジェクトを作成できないように変更しました
- パスワードフィールドをデータベース上で暗号化して保存するように変更しました
- ジョブフロー数制限超過状態のときに警告メッセージを表示するように変更しました

### 修正
- 存在しない型オブジェクトを関連付けたテーブルをインポートするとそのテーブルを開くことができない問題を修正しました

---
## Ver.1.6.1.post4 (2020/12/11)

### 修正
- jobmngr モードでインストールしたとき kompira_sendevt が実行できない問題を修正しました。
- ifブロックやcaseブロックの条件判定式や単純ブロックの束縛式において未定義変数のチェックがされない問題を修正しました。
- サロゲートペアを含む文字列を表示しようとするとエラーになりプロセスの表示や中止ができなくなる問題を修正しました。

---
## Ver.1.6.1.post3 (2020/11/19)

### 修正
- safe_sourceライブラリ間のインポートにおいてジョブフローの呼び出し順序によってはUndefined attribute errorとなる問題を修正しました。
- リファレンスマニュアルの`__winrs_scheme__`のデフォルト値の記述を`http`から`https`に修正しました。

---
## Ver.1.6.1.post2 (2020/11/09)

### 変更
- and/or 論理演算子の短絡評価に対応しました。

### 修正
- ユーザ情報のディレクトリに移動するとメニューバーのユーザ名がそのユーザになってしまう問題を修正しました。
- サマータイム切り替わりの前後でAmbiguousTimeErrorが発生しInternal Server Errorとなる問題を修正しました。
- オブジェクト配列や辞書で相対パスでエクスポートしたデータをインポートすることができない問題を修正しました。
- Windowsノードの reboot() 時に $STATUS=-1 となる問題を修正しました。
- テーブル一覧の画面が微妙に切れる問題を修正しました。
- メールチャネルで無効化に設定しているにもかかわらず初回だけメールフェッチしてしまう問題を修正しました。
- not foundページのメッセージが表示されない問題を修正しました。
- マニュアルにinstall.shではVer1.6へのメジャーバージョンアップができないことを明記しました。
- テーブル表示において、配列や辞書フィールドでのソートを禁止しました。
- スケジュール削除時の確認ダイアログに英語が混じっている問題を修正しました。
- Windows ノードに対するファイル転送時にエラーになる問題を修正しました。
- ディレクトリ一覧の画面を5分以上開いていると、型選択肢が表示されなくなる問題を修正しました(タイムアウトを1時間に延長)。
- README.mdのハードウェア要件の記載を修正しました。
- システム情報のログインユーザが正しく表示されない問題を修正しました。
- スケジュール設定の編集でパラメータを削除できない問題を修正しました。

---
## Ver.1.6.1.post1 (欠番)

---
## Ver.1.6.1 (2020/09/30)

### 変更
- RHEL/CentOS 8系の冗長構成のCorosyncのトランスポートをudpuからknetに変更しました。
- ifブロックのthen/else節、case/choiceブロックの全ての節でセットされている変数については、後続のジョブでの変数参照を許すように変更しました。

### 修正
- 冗長構成において、ハートビート切断時の状況によって、フェールオーバー失敗する問題を修正しました。
- ジョブフローの未定義変数チェックで、一部チェック漏れがあった箇所をエラーとするように修正しました。
- ショートカットキーで"~"を押した時、ホームディレクトリに遷移せずに not found となる問題を修正しました。
- 高負荷時にジョブフロープロセスの中止が効かなくなることがある問題を修正しました。

### 改善
- RHEL/CentOS 8系の冗長構成において、RabbitMQの初回起動に時間がかかる時間を短縮しました。
- RHEL/CentOS 8系の冗長構成において、RabbitMQのモニタリングにかかる負荷を軽減しました。

---
## Ver.1.6.0 (2020/09/18)
### 修正
- 1.6で新規追加された機能の説明をマニュアルに追記しました。
- インシデントを完了した際に、入力フィールドが無効化されない問題を修正しました。
- while, if, tryブロックなどで新規代入された変数をブロック外で参照した際に未定義変数参照エラーとなるようにしました。
- 単純ブロックで新規代入された変数はブロック外でも参照できる(未定義変数参照エラーとならない)ようにしました。
- safe_sourceライブラリ実行中にkompiradが終了できない問題を修正しました。
- 設定オブジェクトの型フィールドの修飾子の変更が反映されない問題を修正しました。
- get_keys()メソッドで取得したキー配列にインデックスでアクセスできない問題を修正しました。
- Ver1.5 の kompira_sendevt からKey-Value形式のアラートを受信できない問題を修正しました。
- テーブルのフィールド検索で型変換できない文字列を入力した場合に500エラーが発生する問題を修正しました。
- 画面幅を縮めた時にメニューバーの項目が消える問題を修正しました。その他UIまわりの修正と調整を行いました。

---
## Ver.1.6.0.beta4 (2020/09/01)
### 修正
- フォームの辞書フィールドからジョブフローに正しくパラメータが渡せない問題を修正しました。

---
## Ver.1.6.0.beta3 (2020/09/01)
### 修正
- select2 関連のファイルを内蔵することで外部への接続を不要にしました。
- Dictionary<Boolean>, Array<Boolean> のフィールドで False 要素があると正しく保存できない問題を修正しました。
- 冗長構成をセットアップしたときに memcached サービスが無効になっていなかった問題を修正しました。
- CentOS/RHEL 8 環境で ja ロケールが有効でない場合があり、言語パックをインストールするように修正しました。
- CentOS/RHEL 8 環境でも /etc/sysconfig/httpd で httpd サービスの環境変数を指定するように修正しました。
- CentOS/RHEL 8 環境では httpd に LANG だけでなく LC_ALL 環境変数を指定するように修正しました。
- 冗長構成に順序制約を追加して、rabbitmq が started 状態になってから webserver を起動するように修正しました。
- kompira_jobmngrd が単体でインストールできない問題を修正しました。
- kompira_jobmngrd が -c オプションを指定しないとき設定ファイルを読み込まない問題を修正しました。

### 変更
- ノード情報型の use_shell のデフォルト値を true から false に変更しました。
- リポジトリ連携型の repositoryType のデフォルト値を "mercurial" から "git" に変更しました。

---
## Ver.1.6.0.beta2 (2020/08/27)
### 修正
- /system/config のSMTPサーバ設定が反映されない問題を修正しました。
- プロセス制御 REST-API の結果が JSON になっていない問題を修正しました。
- スクリプトジョブの中止に失敗する場合がある問題を修正しました。
- 型オブジェクトやフォームオブジェクトを新規作成時に、空欄の「フィールド名」がある状態で保存ボタンを押すと無限リダイレクトになる問題を修正しました。
- ディレクトリやテーブルに設定した「ページサイズ」が一覧表示に反映されていない問題を修正しました。
- オブジェクト表示時に、Array<Password> および Dictionary<Password> フィールドのパスワードがそのまま表示されてしまう問題を修正しました。
- オブジェクト編集時に、Array<Password> および Dictionary<Password> フィールドの新規追加した行では「パスワードを表示する」が機能しない問題を修正しました。
- スクリプトオブジェクトの編集画面で、エディタが有効になっていない問題を修正しました。
- RHUI/RHEL 7 環境でのインストールに対応しました。

---
## Ver.1.6.0.beta1 (2020/08/14)

### beta 版の注意点
- ブラウザアクセスによる画面レイアウトが最適化されておらず、表示が乱れるところがあります。また、画面上での操作性が悪いところもあります。
- 性能面や安定性については、まだ検証が行なえていません。
- オンラインドキュメントが更新されていません。

### v1.6 の特徴

#### Python 3 対応

- 処理系が Python 2.7 から Python 3 系（Python 3.6以上）に移行しました。
- Python 3 がインストールされていない環境では、インストーラが自動的に Python 3 をインストールします。

#### CentOS 8 / RHEL 8 対応

- CentOS 8 および RHEL 8 にインストールできるようになりました。
- CentOS 7 および RHEL 7 にも引き続きインストール可能です。
- CentOS 6 および RHEL 6 はサポート対象外となり、インストールできなくなりました。

#### ソフトウェアのアップデート

Kompira が利用するソフトウェアをアップデートしました。アップデートした主要なソフトウェアを以下に示します。

- ミドルウェア
    - python 3.x (3.6以上)
    - postgresql 12.x
    - rabbitmq 3.8.x
    - memcached [New]
- Python ライブラリ
    - amqp 2.5.x
    - django 3.0.x
    - djangorestframework 3.11.x
    - django-select2 7.2.x
    - psycopg2-binary 2.8.x
    - apscheduler 3.6.x
    - invoke 1.4.x [New]
    - fabric 2.5.x
    - pywinrm 0.4.x
- JavaScript ライブラリ
    - jquery 3.5.x

### v1.6 新機能ガイド

- バイナリデータを扱えるようになりました。
    - v1.5 までは Unicode 文字列とバイナリデータを曖昧に利用できている機能がありましたが、v1.6 では明確に区別されるようになります。
    - ジョブフローでは `b'\xe3\x81\x93\xe3\x82\x93\xe3\x81\xab\xe3\x81\xa1\xe3\x81\xaf'` などのように、`b` プレフィックスでバイナリリテラルを記述できます。
    - ジョブフローでバイナリデータを `print()` すると、バイナリリテラル表記の形式でコンソールに表示されます。
    - バイナリデータ型は `decode()` メソッドを持ち、文字列型に変換できます。
    - 同様に文字列型には `encode()` メソッドが追加され、バイナリデータ型に変換できます。
    - バイナリデータの `type()` の結果は `"Binary"` になります。
- 浮動小数点データを扱えるようになりました。
    - 除算の結果は常に浮動小数点になります（v1.5 では整数型でした）。
    - 剰余の結果は第二引数と同じ型になります（v1.5 では整数型でした）。
    - 浮動小数点データの `type()` の結果は `"Float"` になります。
- 型オブジェクトのフィールド種別として利用できる種別が増えました。
    - `Binary`: バイナリデータ
    - `Float`: 浮動小数点データ
    - `Dictinary<T>`: 型 `T` の辞書データ
    - `Array<T>`: 型 `T` の配列データ
- コマンド出力のリアルタイム表示
    - 実行ジョブによるコマンドの標準出力や標準エラー出力を随時コンソールに表示するようになりました（v1.5 まではコマンドが終了するまで出力が表示されませんでした）。
    - ただしブラウザがコンソールをリロードする間隔（1～5秒程度）より素早くは表示されません。
- コマンド出力のバイナリ対応
    - コマンド出力は通常文字列であることを期待していますが、バイナリとして受け取ることができるようになりました。
    - コマンド実行時に `__raw_stdout__ = true` と指定しておくことで、標準出力をバイナリとして受け取ります。
    - 同様に標準エラー出力をバイナリとして受け取りたい場合は `__raw_stderr__ = true` と指定します。

### v1.5 以前から v1.6 に移行する場合の注意点

- Kompira enterprise v1.5 以前から v1.6 へのアップデートインストールはできません。新しいサーバ環境を用意するか、v1.5 以前の環境を完全に削除して新規インストールする必要があります。
- v1.5 以前から移行される場合は、一度 manage.py export_data コマンドを用いてデータをエクスポートした後、Kompira 1.6.0 をインストールしてから manage.py import_data コマンドを用いてインポートしなおしてください。
- v1.5 以前のジョブフローは、多くの場合そのまま v1.6 でも動作しますが、仕様変更に関わる機能を利用している箇所では修正が必要な場合もあります。
- v1.5 以前の Kompira からジョブフローやライブラリを移植する場合、基本的にはすべての機能・動作を再確認してください。
- とくにライブラリオブジェクトは処理系の Python が 2 系から 3 系（3.6以上）に変更になっているため、すべての実装を見直す必要があります（そのまま動作する可能性もあります）。
- Kompira オブジェクトのフィールド値やジョブフローにおいて、文字列データとバイナリデータが明確に区別されるようになりました。バイナリデータを扱っていた箇所については、実行時にエラーになる可能性があるため、実装を見直す必要があります。
    - サーバ上のファイルを扱っている箇所
    - Kompiraオブジェクトの添付ファイルを扱っている箇所
    - 外部連携においてバイナリデータを扱っている箇所

---
## Ver.1.5.5.post8 (2020/06/22)
### 修正
- issue #1414: スケジューラで毎日0時0分実行が登録できない問題を修正
- issue #1415: parsedatetime のインポートエラーが発生して kompira のインストールに失敗する問題を修正
- issue #1416: Windows の reboot() で再起動後の待ち時間中に内部エラーが発生する問題を修正
- issue #1417: 同時起動スケジュールが多数あると後方のスケジュールがいつまでも起動しない場合がある問題を修正

---
## Ver.1.5.5.post7 (2020/04/07)
### 修正
- pgdg-redhat リポジトリの変更によりインストールに失敗する問題を修正しました (#1411)
- インポート後にライブラリが実行不可になる場合がある問題を修正しました (#1398)
- インストール時およびextraパッケージ作成時に追加のrpmパッケージやpipモジュールを指定できるようにしました (#1408)

---
## Ver.1.5.5.post6 (2020/03/17)
### 修正
- issue #1409: v1.5.5.post5 でプロキシ経由でのインストールに失敗する問題を修正しました。

---
## Ver.1.5.5.post5 (2020/03/12)
### 修正
- issue #1393: kompira_jobmngrd で FRAME_ERROR が発生することがある問題を修正しました。
- issue #1394: proxy パスワードに記号を含む場合にインストーラが正しく処理できないことがある問題を修正しました。
- issue #1397: mail_parse() でパースされたヘッダの文字が欠落していることがある問題を修正しました。
- issue #1399: ip link コマンドで MAC アドレスが取得できないときインストールに失敗する問題を修正しました。
- issue #1400: 正規表現マッチ中にプロセスを中止するとデッドロックすることがある問題を修正しました。
- issue #1405: ライブラリ関数内で例外が発生したときにジョブフローが無限待ちになる場合がある問題を修正しました 。

### 拡張
- issue #1402: mailto送信時のシステム設定(/system/config)でSSL(SMTPs)プロトコルに対応しました。

### その他
- Kompira enterprise ライセンス利用規約が Ver.6.2 に改定されました。

---
## Ver.1.5.5.post4 (2020/02/11)
### 修正
- issue #1389: virtualenv のアップデートに伴い kompira のインストールが失敗する問題を修正しました。

---
## Ver.1.5.5.post3 (2020/02/05)
### 修正
- issue #1378: データベースのロック制御を見直して VACUUM 処理と競合しないように改善しました。
- issue #1371: 不正なパスを含む URL でアクセスした画面からリダイレクトしたときにアクセスエラーになることがある問題を修正しました。
- issue #1374: メールヘッダに含まれるエンコード情報が不正なときに mail_parse() がエラーになる問題を修正しました。
- issue #1373: スケジューラの起動頻度が高いとデータベース接続エラーが発生することがある問題を修正しました。
- issue #1372: 繰り返し回数の非常に多いイテレートを実行するとメモリ使用量が増大する問題を改善しました。
- issue #1349: LANG が設定されていない環境で kompira_sendevt を実行すると No handlers could be found for logger "kompira" とエラーになる問題を修正しました。

### 変更
- Webアクセス
    - リダイレクト時の Location を絶対 URL から相対 URL に変更しました。
- ライブラリ
    - ライブラリオブジェクトの関数内で sys.exit()/os._exit() した場合ジョブフロープロセスを終了させるようにしました。

### その他
- パフォーマンス改善
    - 子要素を含むオブジェクトの名前変更および移動時のパフォーマンスを改善しました。
    - 不要なライセンスチェックを抑制してオーバーヘッドを低減しました。

---
## Ver.1.5.5.post2 (2019/11/25)
### 修正
- issue #1366: [v155] kompira_jobmngrd 単体のインストールに失敗する問題を修正しました。

---
## Ver.1.5.5.post1 (2019/11/12)
### 修正
- issue #1362: 日本語名のテーブルに含まれるオブジェクトの名前を変更するとエラーが表示される問題を修正しました。
- issue #1321: 添付ファイルを持つオブジェクトの削除に時間がかかる場合がある問題を改善しました。
- issue #1359: 設定オブジェクトのフィールド表示名をクリックすると表示名が消える問題を修正しました。
- issue #1360: ライブラリオブジェクトをインポートしたときにエラーが表示されることがある問題を修正しました。

### 変更
- 管理コマンド
    - 書き込みできない場所に対する manage.py export_dir コマンドを異常終了するように変更しました。

### その他
- パフォーマンス改善
    - テーブルの children ビューでは子要素数の annotation を廃止してクエリ速度を改善しました。
    - ディレクトリのViewとAPIViewで子要素に関する annotation を使い分けることでクエリ速度を改善しました。

---
## Ver.1.5.5 (2019/10/29)
- Ver.1.5.5.rc1 から内容に変更はありません。

---
## Ver.1.5.5.rc1 (2019/10/29)
### 修正
- issue #1337: ライブラリからライブラリを呼び出した際に、呼び出された側のライブラリのモジュール内変数の値が None になってしまう問題を修正しました。
    - ロード済みのライブラリに変更が無い場合は再読み込みしないようにすることで対処しました。
    - あるジョブフロープロセスでライブラリの参照を保持したまま、そのライブラリを書き換えて別のジョブフロープロセスで新たに同ライブラリを参照するような使い方をすると、同様の問題が発生する可能性があるのでご注意ください。
- issue #1357: ブラウザからのオブジェクト検索に日本語を指定すると失敗する問題を修正しました。
- issue #1356: [155a] テーブルでの検索時に `annotate() + distinct(fields) is not implemented.` というエラーが発生する問題を修正しました。

### 変更
- パフォーマンス改善
    - ライブラリオブジェクトおよび含まれる関数の参照時間を改善しました。
    - オブジェクト一覧表示画面などでのデータベースアクセス時間を改善しました。

---
## Ver.1.5.5.beta2 (2019/10/24)
### 新機能
- ジョブフロー
    - urlopen のレスポンスに HTTP バージョンを含めるようにしました。

### 修正
- issue #1338: [v155a] パフォーマンス劣化の要因となった atfork ライブラリの修正版を同梱するようにしました。
- issue #1350: [v155a] source ライブラリ呼び出し時にメモリリークしていた問題を修正しました。
- issue #1347: pacemaker が stop しているときに sync_master すると失敗することがある問題を修正しました。
- issue #1352: ジョブフロー数が多い時に kompirad 起動時にタイムアウトする問題を修正しました。
- issue #1344: 上書きインポート時にフィールド定義の変更が反映されない問題を修正しました。

### 変更
- ログ
    - **【重要】 postgresql のログ出力先を /var/log/postgresql/postgresql.log に変更しました。**
- インストール
    - ライセンス切れ状態では kompira のインストールに失敗するように変更しました。
- パフォーマンス改善
    - パフォーマンス向上のためにデータベースにインデックスを追加しました。

---
## Ver.1.5.5.beta1 (2019/08/30)
### 新機能
- ジョブフロー
    - ディレクトリおよびテーブルに対して for ブロックや children プロパティを用いると、オブジェクトのリストがデフォルトのソート順で読み込まれるようになりました。
    - datetime() / date() / time() で相対的な日時指定ができるようになりました。
    - find メソッドで type_object および owner に対してルックアップ 'in' が利用できるようになりました。
    - チャネルリストでの受信待ちができるようになりました。
- データモデル
    - ディレクトリおよびテーブルに、デフォルトのソート順とページサイズを保存するフィールドを追加しました。
    - Datetime / Date / Time 型フィールドのデフォルト値に相対的な日時指定ができるようになりました。
- 外部連携
    - Windows サーバに対する PUT/GET リモートタスクを機能強化しました。
- 画面操作
    - ブラウザ上のテキストエディタが機能強化しました。
    - ディレクトリおよびテーブル画面でデフォルトのソート順とページサイズが適用されるようになりました。
    - 操作したオブジェクトに自動的にフォーカスされるようになりました。
    - テーブル画面での検索機能を強化しました。

### 修正
- issue #1343: abort() にバイナリデータを渡すと abort 自体に失敗してしまい try でキャッチできない問題を修正しました。
- issue #1336: チェックポイントモードのプロセスが再開しても待ち状態のまま動作が再開しない場合がある問題を修正しました。
- issue #1335: オブジェクトのparent_objectの型オブジェクト固有のメソッドが呼び出せない問題を修正しました。
- issue #1328: ディレクトリのツリー表示時にメモリ不足になる場合がある問題を修正しました。
- issue #1325: sshノードに対する sudo でパスワードが間違えている場合に正しく認識できない場合がある問題を修正しました。
- issue #1318: 否定条件を複数組み合わせた場合の find 結果が正しくない問題を修正しました。
- issue #1317: DBアクセス処理中にジョブフローを停止すると、kompirad がデッドロックすることがある問題を修正しました。
- issue #1313: getで日本語パス+ワイルドカード指定するとエラーになる問題を修正しました。
- issue #1314: ライブラリオブジェクトでエンコード宣言の記述が無いと文字列リテラルが化ける問題を修正しました。
- issue #1312: winrmの戻り値が負の値を取るとジョブフローが終了しない問題を修正しました。
- issue #1309: APIアクセス時にライセンスオブジェクトの extra_properties が展開されない問題を修正しました。
- issue #1307: 文字列フィールドでmin_length=1を指定しても、０文字が入力できてしまう問題を修正しました。
- issue #1298: Windowsサーバに対してreboot()すると再起動完了前にジョブが正常終了してしまうことがある問題を修正しました。
- issue #1297: Windowsサーバに対してreboot()するとジョブが異常終了する問題を修正しました。
- issue #1293: ライブラリ保存時にUnicodeEncodeErrorが出る場合がある問題を修正しました。
- issue #1282: sourceライブラリの呼び出した関数内でpythonが落ちるとプロセスが実行中のまま進まなくなる問題を修正しました。

### 変更
- 画面操作
    - オブジェクト編集時に画面遷移確認される画面が増えました。
    - ショートカットキーを利用できる画面が増えました。
- ジョブフロー
    - 正規表現マッチ中にも別のジョブフロープロセスが動作できるようになりました。
    - コマンドジョブ実行時に参照する管理領域情報をキャッシュするようになりました。

### 制限事項
- ライブラリ
    - v1.5.4 で対応した「ライブラリオブジェクトから別のライブラリオブジェクトの関数を呼び出し」において、呼び出された側のライブラリのモジュール内変数の値が None になってしまう場合があります。(v1.5.4 から存在)
        - 発生条件（タイミングにも依存するので厳密ではありません）
            - ライブラリオブジェクト（Ａ）で定義した関数をジョブフローで利用している。
            - ライブラリオブジェクト（Ａ）をインポートしているライブラリオブジェクト（Ｂ）で定義した関数をジョブフローで利用している。
            - ライブラリオブジェクト（Ａ）およびライブラリオブジェクト（Ｂ）が safe_source ライブラリである。
            - ライブラリオブジェクト（Ａ）が複数の経路で複数回ロードされる。
        - 回避方法
            - 別ライブラリオブジェクトからインポートされるライブラリオブジェクト（上ではＡ）の関数を複数の経路で利用しないようにする。
            - 別ライブラリオブジェクトからインポートされるライブラリオブジェクトではモジュール内変数を利用しないようにする。

### その他
- エクスポート操作をログに出力するようにしました。
- javascript ライブラリをアップデートしました。
    - Codemirror (5.48.0)
    - jsTree (3.3.8)
- プロセス管理用コマンドを追加しました。
    - /opt/kompira/bin/manage.py process

---
## Ver.1.5.4.post5 (2019/03/29)
### 修正
- issue #1291: try ブロックで異常をキャッチしたときプロセスの情報が更新されない問題を修正しました。
- issue #1290: try ブロックを抜けたところでジョブが終了するとプロセスの実行行番号が 0 になる問題を修正しました。
- issue #1288: proxy 環境下でのインストールに失敗することがある問題を修正しました。
- issue #1285: urlopenでの POST 時に文字列データを渡すとエラーになる問題を修正しました。
- issue #1287: 終了待ちしている子プロセスが削除されると、forkブロックやpforブロックが終了しない問題を修正しました。
- issue #1280: pforのプロセス数が0の場合、ジョブフローがスタックする問題を修正しました。
- issue #1152: mktemp が無い環境でのスクリプトジョブ実行に失敗する問題を修正しました。
- issue #1221: winrm 接続時のタイムアウト制御の挙動を改善しました。

### 変更
- ジョブフロー
    - issue #1252: リモートログイン失敗時にエラーメッセージを $ERROR 変数にセットするようにしました。
    - issue #1286: SSHで踏み台ログイン失敗時のエラーメッセージを分かりやすく改善しました。
    - issue #1262: __sudo__ = true かつ __use_shell__ = false のとき __dir__ は指定できないので、分かりやすくエラーメッセージを改善しました。

---
## Ver.1.5.4.post4 (2019/02/20)
### 修正
- issue #1281: 冗長構成でハートビート用インターフェースが自動起動しない場合がある問題を修正しました。
- issue #1278: upload()メソッド実行時に存在しないフィールドを指定すると無限待ちに陥る問題を修正しました。
- issue #1269: RHUI 環境における冗長構成スクリプトの動作を改善しました。

### 変更
- 冗長構成
    - 冗長構成における kompirad 起動時タイムアウト60秒から180秒に延長しました。

---
## Ver.1.5.4.post3 (2019/02/13)
### 修正
- issue #1275: フィールド値を書き換えてもオブジェクトの更新日時が更新されない場合がある問題を修正しました。
- issue #1276: 冗長構成においてHTTPアクセスできない場合がある問題を修正しました。
- issue #1277: 冗長構成の HTTP サービスで環境変数の設定が適用されない問題を修正しました。

### 変更
- テキストオブジェクト
    - テキストオブジェクトのコンテクスト置換機能について、コンテクストオブジェクトが未指定の時は、この置換機能を無効化しました。
- 冗長構成
    - 冗長構成におけるhttpd監視対象URLをリダイレクト不要なものに変更しました。

---
## Ver.1.5.4.post2 (2019/02/01)
### 修正
- issue #1272: 特権でないユーザがインシデントを正しく作成できない問題を修正しました。
- issue #1271: 複数グループに所属するユーザが一覧で複数表示されてしまう問題を修正しました。
- issue #1268: タスクのcloseを呼び出しても完了日時がNoneのままになる問題を修正しました。
- issue #1255: チャネルの削除とメッセージの送受信を同時にすると、DBがデッドロックすることがある問題を再修正しました。

---
## Ver.1.5.4.post1 (2019/01/09)
### 修正
- issue #1265: リポジトリ連携ライブラリをインポートした時点で環境変数LANGがen_USになる問題を修正しました。
- issue #1263: ディレクトリ形式インポート時にユーザ定義型のオブジェクトがインポートできない問題を修正しました。
- issue #1261: Windows にインストールした kompira_sendevt で日本語データを送信できない問題を修正しました。

---
## Ver.1.5.4 (2018/12/27)
### 新機能
- 外部連携
    -  リポジトリオブジェクトで mercurial に加えて git リポジトリと連携できるようになりました。
- REST API
    - 新しいインシデントを REST-API で作成できるようになりました。
        - /incident に対する POST アクセスでインシデントを作成できます。
- ライブラリ
    - [experimental] ライブラリオブジェクトの関数を JSON-RPC で呼び出すことができるようになりました。
        - ただし safe_source タイプのライブラリオブジェクトに限ります。
        - エンドポイントはライブラリオブジェクトのパス + .jsonrpc となります。
            - 例：/root/mylib というライブラリであれば /root/mylib.jsonrpc となります。
    - [experimental] ライブラリオブジェクトから別のライブラリオブジェクトの関数を呼び出せるようになりました。
        - 別ライブラリオブジェクトは、PEP-328 で規定される絶対インポートまたは相対インポートが可能です。
- 画面操作
    - インシデント一覧画面でインシデント状態ごとにフィルタリングできるようになりました。
    - インシデント一覧画面に表示できる列を増やしました。
    - インシデント一覧画面に検索機能を追加しました。
    - プロセス一覧画面に検索機能を追加しました。
    - 右上のユーザメニューに「ユーザ情報」と「パスワード変更」へのリンクを追加しました。
- 冗長構成
    - 冗長構成のセットアップ時に VIP を割り当てるネットワークインターフェースを指定できるようになりました。

### 変更
- ユーザ管理
    - 特権ユーザは元のパスワードを入力せずにパスワードを変更できるようにしました。
- ライブラリ
    - ライブラリオブジェクトの内部的なモジュール名の命名方法を変更しました。
        - 旧：kompira.library. + ライブラリオブジェクトの名称
        - 新：kompira.library.objects + ライブラリオブジェクトのパス（/ は . に置換）
            - 例：/root/mylib というライブラリであれば kompira.library.objects.root.mylib となります。
    - ライブラリオブジェクト内部でのインポート方式を絶対インポートに変更しました。
        - 自動的に from __future__ import absolute_import が適用されます。
- インポート
    - オブジェクトのインポート時に更新日時を復元するようにしました。

### 修正
- issue #1138: リポジトリ連携で空テーブルや空ディレクトリが作成されない問題を修正しました。
- issue #1218: 特定の名称を持つライブラリオブジェクトを正常に呼び出せない問題を修正しました。
- issue #1242: dateオブジェクトのweekdayプロパティが正しい値を返さない問題を修正しました。
- issue #1241: datetimeオブジェクトのformat()メソッドが異常終了する問題を修正しました。
- issue #1248: REST API でスケジューラを登録するとき、日時週などに不正な値を指定してもエラーにならない問題を修正しました。
- issue #1250: セッションブロックでリモートから切断したときにジョブマネージャのセッションが終了しない場合がある問題を修正しました。
- issue #1255: チャネルの削除とメッセージの送受信を同時にすると、DBがデッドロックすることがある問題を修正しました。
- issue #1257: Windows へのファイル put で正常にファイル転送できない場合がある問題を修正しました。

---
## Ver.1.5.3 (2018/11/16)
### 新機能
- ジョブフロー
    - ジョブ/ライブラリ呼び出しの引数に対して、配列や辞書を *args や **kwargs のように展開して渡せるようになりました。
    - 日付および時刻を扱う Date 型と Time 型を追加しました。
        - date() 組み込み関数で、指定された文字列から日時データに変換できます。
        - time() 組み込み関数で、指定された文字列から時刻データに変換できます。
    - mailto() 組込みジョブに charset 引数を追加して送信時の文字コードを指定できるようになりました。
        - charset="iso-2022-jp" などと指定できます。
        - ただし python の仕様で shiftjis や eucjp を指定しても iso-2022-jp にエンコードされます（対応検討中）。
- データモデル
    - 日付および時刻を記録する Date フィールドと Time フィールドを追加しました。
- 外部連携
    -  メールチャネルで IMAP サーバへのログイン時に CRAM-MD5 認証に対応しました。
- 画面操作
    - リポジトリ連携でプッシュするときにコミットメッセージが入力できるようになりました。

### 変更
- issue #1237: kompirad ワーカプロセスのメモリ制限デフォルト値を 1GB から 4GB に変更しました。

### 修正
- issue #1239: [security] 認証を経由せずに Kompira API で GET アクセスできてしまうことがある問題を修正しました。
- issue #1220: メールチャネルで長すぎる行を含むメールのフェッチに失敗することがある問題を修正しました。
- issue #1163: メールボックスに大量にメールが存在する場合にメールチャネル(IMAP)で受信できないことがある問題を修正しました。
- issue #1105: mailto でメールを送信する際に本文に長すぎる行を含んでいると、メール配送中に改行が挿入され文字化けする場合がある問題を修正しました。

### その他
- CentOS6系でのテストの安定性を向上しました。

---
## Ver.1.5.2 (2018/10/30)

### 新機能
- ジョブフロー
    - 文字列型に format(), join(), find() などの、文字列操作用メソッドを追加しました。
    - 辞書型にキー一覧を取得する get_keys() メソッドを追加しました。
    - 浮動小数点を扱えるように float() 組み込み関数を追加しました。
    - datetime 型に ISO 文字列を取得する isoformat() メソッドを追加しました。
    - timedelta 型にトータルの経過秒数を取得する total_seconds プロパティを追加しました。
    - [experimental] ディレクトリ型にオブジェクトの検索ができる find() および glob() メソッドを追加しました。
- REST API
    - テーブルに対する .children API で以下のようにフィールド値による並び替えを指定できるようにしました。
        - order_by=field:<フィールド名>      (昇順)
        - order_by=-field:<フィールド名>     (降順)
    - REST-API のフィルタリングで、以下のようにフィールド値の絞込み／範囲指定をできるようにしました。
        - field:<フィールド名>=<値> 
        - field:<フィールド名>__<ルックアップ>=<値> 
- 画面操作
    - テーブル編集画面に「表示フィールドの追加」メニューを追加しました。
    - プロセス一覧画面で「正常終了したプロセス」「異常終了したプロセス」をフィルタリングできるようにしました。
    - ディレクトリや検索ビューの画面遷移でページサイズとソート順を保持するようにしました。

### 変更
- ディレクトリ一覧画面などでの日時表記フォーマットを YYYY/MM/DD hh:mm::ss 形式に変更しました。
- 一覧画面で選択可能な表示件数を 1000 まで拡張しました。


### 修正
- issue #1222: ファイル名にNFDエンコードされた濁点を含む場合にディレクトリインポートに失敗する問題を修正しました。
- issue #1225: オブジェクト選択フィールドでページ送りが出来ない問題を修正（暫定対処）しました。
- issue #1227: sendevt モードでのインストール時に失敗することがある問題を修正しました。
- issue #1228: CentOS6 系でのテストに失敗することがある問題を改善しました。

### その他
- ディレクトリ一覧画面やプロセス一覧画面において表示パフォーマンスを改善しました。
- javascript ライブラリをアップデートしました。
    - js.cookie (2.2.0) [New]
    - Moment (2.22.2) [New]
    - JsRender (0.9.91)

---
## Ver.1.5.1 (2018/09/14)

### 新機能
-  英語対応および英語版ドキュメントを添付しました。
    - インストール時の言語設定によって日本語または英語設定になります。
    - インストール時に --locale-lang オプションで言語を指定可能です（システムの言語設定を変更します）。
    - デフォルトではシステムの言語設定を変更しません（【非互換】以前のバージョンでは日本語に変更していました）。
    - 日本語(ja_JP.UTF-8)および英語(en_US.UTF-8)でのみ動作確認しています。
- 型オブジェクトの編集画面で、フィールド修飾子をポップアップダイアログで編集できるようになりました。
- フィールド修飾子に指定できる項目を追加しました。
    - Array/Dictionary型: default でデフォルト値が指定できるようになりました。
    - String型: max_length で最大長を指定できます。
    - String型: pattern で入力可能な文字列パターンを正規表現で指定できます。
    - Integer型: min_value/max_value で最小値／最大値を指定できます。
    - File型: file_accept でファイル選択ダイアログで表示するファイル種別を指定できます。
- 配列・辞書フィールドの順序入れ替えが簡単にできるようになりました。
    - ドラッグアンドドロップによる順序入れ替え、CTRL + 上下カーソルキーによる入れ替えができます。
- インシデントをWeb画面から新規作成できるようになりました。
- ジョブフローからプロセスの監視モードを monitoring_mode で読み書きできるようになりました。

### 変更
- mailto() の Date ヘッダをローカルタイムになるようにしました。
- REST API で API キーによる認証を cookie より優先するようになりました。
- manage.py export_dir コマンドによるエクスポート時に権限情報を出力できるようになりました。

### 修正 
- issue #1004: forkプロセス、スケジューラやAPIから起動したジョブフローでも、監視モードに応じてメール通知されるように修正しました。
- issue #1031: mailto() で日本語添付ファイル名の扱いを修正しました。
- issue #1208: 長すぎるフィールド修飾子を指定したオブジェクトの作成でエラーになる問題を修正しました。
- issue #1215: 多重度設定したジョブフローの並列実行が終了しない問題を修正しました。
- issue #1216: $RESULTや$ERRORに日本語を含むプロセスオブジェクトをmanage.py dumpdataできない問題を修正しました。

### その他
- pythonライブラリをアップデートしました
    - mod_wsgi (4.5.24 → 4.6.4)
    - psycopg2 (2.6.2) → psycopg2_binary (2.7.5)
    - psutil (5.4.6) [New]
- javascript ライブラリをアップデートしました。
    - jquery-ui (1.12.1) [New]

---
## Ver.1.5.0 (2018/07/05)

### プラットフォームの移行

#### Python2.7 対応

- Python 2.7 系に対応し、Python 2.6 系は非対応となりました。
- Python 2.7 がインストールされていない環境では、インストーラが自動的に Python 2.7 をインストールします。

ジョブフローから実行する python スクリプトなども 2.7 系で実行されることになるため、バージョンに依存するスクリプトを利用する場合は注意してください。

#### CentOS 7 / RHEL 7 対応

- CentOS 7 および RHEL 7 にインストールできるようになりました。
- CentOS 6 および RHEL 6 にも引き続きインストール可能です。

#### ミドルウェアのアップデート

Kompira が利用するミドルウェアをアップデートしました。アップデートした主要なミドルウェアを以下に示します。

- データベース
    - PostgreSQL 9.6
- Python ライブラリ
    - django 1.8.19
    - djangorestframework 3.2.5
    - Django-Select2 4.3.2
    - pywinrm 0.3.0
    - Jinja2 2.10
    - python-daemon 2.1.2
- JavaScript ライブラリ
    - jquery 1.12.4

#### バグ修正

- Kompira オブジェクトのフィールド値書き込み時に、DB 排他制御が不足している場合がある問題を修正しました。
- ジョブフローからメールチャネルを読み込んでも、メールサーバへのポーリングが開始しない場合がある問題を修正しました。

その他の修正については、ChangeLog をご参照ください。

---
## 更新方法

Ver.1.5.0 から、インストーラは標準ではデータを保持してアップデートを試行
するになりました。オプションを付けずに install.sh を実行してください。

    ./install.sh

なお、この変更に伴い --update オプションは廃止になりました。

データ移行のためインストーラがバックアップを作成しますが、データ移行が
不要な場合は --no-backup オプションを付与することで、バックアップを作成
せず更新に必要なディスク容量を削減できます。

    ./install.sh --no-backup

データベースを明示的に初期化する場合は --initdata オプションを付与して
インストーラを実行してください。

    ./install.sh --initdata

なお、1.5.0 より前のデータは移行できません。一度、manage.py の export_data
コマンドを用いてデータをエクスポートした後、Kompira 1.5.0 をインストールし、
import_data コマンドにてインポートしなおしてください。

継続での利用にはライセンスファイルを登録する必要がございますので、ご注
意ください。ライセンスファイルはライセンス申請を行うことで取得可能です。
